-- sort the knights_rooms.txt file (output of kconvert.py) by seg name.
-- the result can then be compared against the saved files from the map editor.

import Data.Char
import Data.List
import Data.Ord
import System.IO

doesntBeginWithHash ('#':_) = False
doesntBeginWithHash _ = True

groupBySegName :: [String] -> [[String]]
groupBySegName [] = []
groupBySegName (hdr:lns) =
    let (thisSeg, otherSegs) = span doesntBeginWithHash lns
    in (hdr : thisSeg) : (groupBySegName otherSegs)

putSegsInOrder :: [[String]] -> [[String]]
putSegsInOrder (a:b:c:d:otherSegs) 
    = (tail b) : (tail $ map rmComments d) : (map tail $ sortBy (comparing head) otherSegs)

rmComments :: String -> String
rmComments = rightTrim . takeWhile (/='#')

rightTrim = reverse . dropWhile isSpace . reverse

sortLines :: [String] -> [String]
sortLines = concat . putSegsInOrder . groupBySegName

main = do
  input <- hGetContents stdin
  let result = (unlines . sortLines . lines) input
  putStr (filter (/='\r') result)
  --print $ (map head . groupBySegName . lines) input
